## NMVpnEditor

NMVpnEditor

## Functions

GObject * | nm_vpn_editor_get_widget ()
gboolean | nm_vpn_editor_update_connection ()

## Types and Values

| NMVpnEditorInterface

## Description

## Functions

### nm_vpn_editor_get_widget ()

    GObject *
    nm_vpn_editor_get_widget (NMVpnEditor *editor);

#### Parameters

editor | the NMVpnEditor |

#### Returns

.

[transfer none]

### nm_vpn_editor_update_connection ()

    gboolean
    nm_vpn_editor_update_connection (NMVpnEditor *editor,
                                     NMConnection *connection,
                                     GError **error);

## Types and Values

### NMVpnEditorInterface

    typedef struct {
        GTypeInterface g_iface;

        GObject *(*get_widget)(NMVpnEditor *editor);

        void (*placeholder)(void);

        gboolean (*update_connection)(NMVpnEditor *editor, NMConnection *connection, GError **error);

        void (*changed)(NMVpnEditor *editor);
    } NMVpnEditorInterface;

Interface for editing a specific NMConnection

#### Members

`get_widget` () | return the GtkWidget for the VPN editor's UI |
`placeholder` () | not currently used |

`update_connection` ()

called to save the user-entered options to the connection object. Should return `FALSE` and set `error` if the current options are invalid. `error` should contain enough information for the plugin to determine which UI widget is invalid at a later point in time. For example, creating unique error codes for what error occurred and populating the message field of `error` with the name of the invalid property.

`changed` () | emitted when the value of a UI widget changes. May trigger a validity check via `update_connection` to write values to the connection. |